# thumbnails.tcl -- generate thumbnails from images.
# $Id: thumbnails.tcl,v 1.2 2003/11/25 10:30:49 davidw Exp $

# I would love to decouple Img from Tk so that this code could run
# without a DISPLAY.
package require Img

namespace eval thumbnails {
    set maxw 200
    set maxh 200
    set scalefactor .2
}

proc thumbnails::imgscale {img factor} {
    set i 0
    set h [image height $img]
    set w [image width $img]
    set data [$img data]

#    puts "$w $h"
#return
#    fconfigure stdout -buffering full
    while {$i < $h} {
	set j 0
	while {$j < $w} {
#	    set pixnum [expr {$i * $w + $j}]
	    set pixel [lindex $data $i $j]
	    scan $pixel \#%2x%2x%2x r g b
	    set r 0xff
	    set pixel [format "#%02x%02x%02x" $r $g $b]
	    lset data $i $j $pixel
# 	    set pix [$img get $i $j]
# 	    puts $pix
# 	    lset pix 1 255
# 	    puts $pix
# 	    $img put $pix -to $i $j $i [expr $j + 1]

 	    incr j
	}
	incr i
    }
    $img put $data
}

proc thumbnails::fromfile {filename} {
    variable maxw
    variable maxh

    set img [image create photo -file $filename]
    set h [image height $img]
    set w [image width $img]
    set hdiff [expr {$h - maxh}]
    set wdiff [expr {$w - maxw}]
    if { $hdiff > $wdiff } {
	scale $img [expr {double($maxh) / $h}]
    } else {
	scale $img [expr {double($maxw) / $w}]

    }
}

package require Tk

set img [image create photo -file logo.jpg]
set img2 [image create photo]
label .before -image $img
$img2 copy $img
thumbnails::imgscale $img2 .3
label .after -image $img2
pack .before
pack .after